/************************************************************************
	Alerts Management
*************************************************************************/	

var alertFrame;

// Show an alert message
function Alert(message, button1, button2, action1, action2)
{
	printFunction("Alert");

	// Create the frame only if it hasn't been created yet
	if(!alertFrame)
	{
		// The alert frame
		alertFrame = new Frame();
		sheetFrame.appendChild(alertFrame);
		
		// Alert frame background
		aBackground = new Image();
		aBackground.src = "Resources/Images/alertMessage.png";
		aBackground.opacity = 240;
		aBackground.onContextMenu = "mainWindow.contextMenuItems = null;";
		alertFrame.appendChild(aBackground);
		
		// Alert message
		aMessage = new Text();		
		aMessage.size = 13;
		aMessage.style.fontWeight = "bold";
		aMessage.hOffset = 21;
		aMessage.vOffset = 9;
		aMessage.width = aBackground.width - 42;
		aMessage.height = 75;
		aMessage.wrap = true;
		alertFrame.appendChild(aMessage);
		
		var leftButtonPos = 108;
		var rightButtonPos = 195;

		// Alert Buttons
		aButton1 = new Button("aButton1", system.platform == "macintosh" ? rightButtonPos : leftButtonPos, aBackground.height - 39, button1, "OnAlertButton1Clicked();", alertFrame);
		aButton2 = new Button("aButton2", system.platform == "macintosh" ? leftButtonPos : rightButtonPos, aBackground.height - 39, button2, action2 ? "OnAlertButton2Clicked();" : "HideSheet();", alertFrame);
	}
	
	// Update alert information
	
	aMessage.data = getShortString(message, 153);
	
	aButton1.label.data = button1;
	aButton2.label.data = button2;
	
	alertFrame.action1 = action1;
	alertFrame.action2 = action2;
	
	UpdateAlertAppearance();
	ShowSheet(alertFrame);
}

// When "alert button 1" is clicked
function OnAlertButton1Clicked()
{
	HideSheet();
	alertFrame.action1();
	alertFrame.action1 = null;
}

// When "alert button 2" is clicked
function OnAlertButton2Clicked()
{
	HideSheet();
	alertFrame.action2();
	alertFrame.action2 = null;
}

function UpdateAlertAppearance()
{
	printFunction("UpdateAlertAppearance");

	aBackground.colorize = getImageColor();;
	aMessage.color = getTextColor();
	aMessage.shadow = getShadowColor();
	aButton1.updateAppearance();
	aButton2.updateAppearance();
}