/************************************************************************
	Feed Settings Dialog
*************************************************************************/	

var fsFrame;

const DEFAULT_UPDATE_FREQUENCY = 30;
const DEFAULT_MAX_FEED_ITEMS = 50;

function ShowFeedSettings(object)
{
	printFunction("ShowFeedSettings");

	if(!fsFrame)
	{
		// "Feed Settings" frame
		fsFrame = new Frame();
		sheetFrame.appendChild(fsFrame);
		
		// "Feed Seetings" background
		fsBackground = new Image();
		fsBackground.src = "Resources/Images/feedSettings.png";
		fsBackground.opacity = 240;
		fsBackground.onContextMenu = "mainWindow.contextMenuItems = null;";
		fsFrame.appendChild(fsBackground);
		
		// Feed title
		fsTitle = new Text();
		fsTitle.hAlign = "center";
		fsTitle.size = 15;
		fsTitle.style.fontWeight = "bold";
		fsTitle.hOffset = fsBackground.width/2;
		fsTitle.vOffset = 19;
		fsTitle.width = fsBackground.width - 30;
		fsTitle.truncation = "end";
		fsFrame.appendChild(fsTitle);
		
		// "Feed URL:"
		fsFeedUrlTitle = new Text();
		fsFeedUrlTitle.hAlign = "right";
		fsFeedUrlTitle.data = loc("feedURL");
		fsFeedUrlTitle.size = 11;
		fsFeedUrlTitle.style.fontWeight = "bold";
		fsFeedUrlTitle.hOffset = 152;
		fsFeedUrlTitle.vOffset = 52;
		fsFrame.appendChild(fsFeedUrlTitle);
		
		//" Feed URL" text area object
		fsFeedUrl.size = 13;
		fsFeedUrl.hOffset = system.platform == "macintosh" ? 158 : 156;
		fsFeedUrl.vOffset = 40;
		fsFeedUrl.width = system.platform == "macintosh" ? 227 : 234;
		fsFeedUrl.height = 19;
		fsFeedUrl.lines = 1;
		fsFeedUrl.scrollbar = false;
		fsFeedUrl.spellCheck = false;
		fsFeedUrl.onKeyPress = function()
		{
			if(system.event.keyString == "Space") fsFeedUrl.rejectKeyPress(); 
		
			if(system.event.keyString == "Tab")
			{
				fsFeedUrl.rejectKeyPress(); 
				fsFeedUTitle.focus();
			}
			
			if(system.event.keyString == "Return" || system.event.keyString == "Enter")
			{
				fsFeedUTitle.rejectKeyPress(); 
				SaveFeedSettings();
			}
		}
		fsFeedUrl.onKeyUp = "fsFeedUrl.data = fsFeedUrl.data.replace(/\\s+/, '');";
		fsFrame.appendChild(fsFeedUrl);
		
		// "Feed Title:"
		fsFeedUTitleTitle = new Text();
		fsFeedUTitleTitle.size = 11;
		fsFeedUTitleTitle.style.fontWeight = "bold";
		fsFeedUTitleTitle.hOffset = 152;
		fsFeedUTitleTitle.vOffset = 87;
		fsFeedUTitleTitle.hAlign = "right";
		fsFeedUTitleTitle.data = loc("feedTitle");
		fsFrame.appendChild(fsFeedUTitleTitle);
		
		// "Feed title" text area object
		fsFeedUTitle.size = 13;
		fsFeedUTitle.hOffset = fsFeedUrl.hOffset;
		fsFeedUTitle.vOffset = 75;
		fsFeedUTitle.width = fsFeedUrl.width;
		fsFeedUTitle.height = 19;
		fsFeedUTitle.lines = 1;
		fsFeedUTitle.scrollbar = false;
		fsFeedUTitle.spellCheck = false;
		fsFeedUTitle.onKeyPress = function()
		{
			if(system.event.keyString == "Tab")
			{
				fsFeedUTitle.rejectKeyPress(); 
				fsFeedUrl.focus();
			}
			else if(system.event.keyString == "Return" || system.event.keyString == "Enter")
			{
				fsFeedUTitle.rejectKeyPress(); 
				SaveFeedSettings();
			}
		}
		fsFrame.appendChild(fsFeedUTitle);
		
		// Feed title's description
		fsfsFeedUTitleDesc = new Text();
		fsfsFeedUTitleDesc.data = loc("feedTitleDescription");
		fsfsFeedUTitleDesc.size = 10;
		fsfsFeedUTitleDesc.style.fontWeight = "bold";
		fsfsFeedUTitleDesc.hOffset = 157;
		fsfsFeedUTitleDesc.vOffset = 106;
		fsFrame.appendChild(fsfsFeedUTitleDesc);
		
		// "Refresh Every:"
		fsRefreshTitle = new Text();
		fsRefreshTitle.hAlign = "right";
		fsRefreshTitle.data = loc("refreshEvery");
		fsRefreshTitle.size = 11;
		fsRefreshTitle.style.fontWeight = "bold";
		fsRefreshTitle.hOffset = 152;
		fsRefreshTitle.vOffset = 129;
		fsFrame.appendChild(fsRefreshTitle);

		// Update frequency popup
		fsRefreshPopup = new Popup("fsRefreshPopup", 155, 116, 
									[loc("numMinutes").replace("%num%", 5),
									loc("numMinutes").replace("%num%", 10),
									loc("numMinutes").replace("%num%", 15),
									loc("numMinutes").replace("%num%", 20),
									loc("numMinutes").replace("%num%", 30),
									loc("1Hour"),
									loc("numHours").replace("%num%", 2), 
									loc("numHours").replace("%num%", 5),
									loc("numHours").replace("%num%", 10), 
									loc("numHours").replace("%num%", 15), 
									loc("1Day")], 
									[5, 10, 15, 20, 30, 60, 60 * 2, 60 * 5, 60 * 10, 60 * 15, 60 * 24], 
									DEFAULT_UPDATE_FREQUENCY, 
									fsFrame);

		// "Number of Visible Items:"
		fsItemsTitle = new Text();
		fsItemsTitle.hAlign = "right";
		fsItemsTitle.data = loc("numOfVisibleItems");
		fsItemsTitle.size = 11;
		fsItemsTitle.style.fontWeight = "bold";
		fsItemsTitle.hOffset = 152;
		fsItemsTitle.vOffset = 164;
		fsFrame.appendChild(fsItemsTitle);
		
		// "Visible items" popup
		fsItemsPopup = new Popup("fsItemsPopup", 155, 151, [5, 10, 15, 20, 25, 50], [5, 10, 15, 20, 25, 50], DEFAULT_MAX_FEED_ITEMS, fsFrame);
		
		var leftButtonPos = 280;
		var rightButtonPos = 358;
		
		// "Save" button
		fsSaveButton = new Button("fsSaveButton", system.platform == "macintosh" ? rightButtonPos : leftButtonPos, 201, loc("save"), "SaveFeedSettings();", fsFrame);
		
		// "Cancel" button
		fsCancelButton = new Button("fsCancelButton", system.platform == "macintosh" ? leftButtonPos : rightButtonPos, 201, loc("cancel"), "HideSheet();", fsFrame);
		
		UpdateFSWindowAppearance();
	}
	
	// Update Controls
	if(typeof(object) == "string")
	{
		// A URL string was passed 
		editedFeed = null;
		fsFeedUrl.data = object;
		fsFeedUTitle.data = "";
		fsRefreshPopup.setValue(fsRefreshPopup.defaultValue);
		fsItemsPopup.setValue(fsItemsPopup.defaultValue);
	}
	else
	{
		editedFeed = object;
		if(object instanceof Feed)
		{
			// An existing feed's settings were passed
			fsFeedUrl.data = editedFeed.url;
			fsFeedUTitle.data = editedFeed.userTitle;
			fsRefreshPopup.setValue(editedFeed.updateFrequency);
			fsItemsPopup.setValue(editedFeed.maxVisibleItems);
		}
		else
		{
			// An invalid value was passed
			fsFeedUrl.data = "";
			fsFeedUTitle.data = "";
			fsRefreshPopup.setValue(fsRefreshPopup.defaultValue);
			fsItemsPopup.setValue(fsItemsPopup.defaultValue);
		}
	}

	fsFeedUTitle.loseFocus();
	
	UpdateFSTitle();
	UpdateFSWindowAppearance();
	ShowSheet(fsFrame);
	
	fsFeedUrl.focus();
	fsFeedUrl.select(0, 0);
}

// Update the "Feed Settings" title - if possible, show the feed's title
function UpdateFSTitle()
{
	printFunction("UpdateFSTitle");

	fsTitle.data = (editedFeed instanceof Feed) ? (editedFeed.getTitle().length > 0 ? editedFeed.getTitle() : loc("feedSettings")) : loc("newFeedSettings");
}

function UpdateFSWindowAppearance()
{
	printFunction("UpdateFSWindowAppearance");

	fsBackground.colorize = getImageColor();
	
	fsFeedUTitle.color = 
	fsFeedUrl.color = 
	fsTitle.color = 
	fsTitle.color = 
	fsFeedUrlTitle.color = 
	fsFeedUTitleTitle.color = 
	fsfsFeedUTitleDesc.color = 
	fsRefreshTitle.color = 
	fsItemsTitle.color = getTextColor();
	
	fsTitle.shadow = 
	fsTitle.shadow = 
	fsFeedUrlTitle.shadow =
	fsFeedUTitleTitle.shadow =
	fsfsFeedUTitleDesc.shadow =
	fsRefreshTitle.shadow =
	fsItemsTitle.shadow = getShadowColor();
	
	fsRefreshPopup.updateAppearance();
	fsItemsPopup.updateAppearance();
	fsSaveButton.updateAppearance();
	fsCancelButton.updateAppearance();
}

function SaveFeedSettings()
{
	printFunction("SaveFeedSettings");

	// Make sure there's a URL specified
	if(fsFeedUrl.data.replace(/\s+/g, '').length > 0)
	{
		var settings = {url: fsFeedUrl.data.replace(/\s+/g, ''), userTitle: fsFeedUTitle.data.replace(/\s+$/g, ''), updateFrequency: fsRefreshPopup.value, maxVisibleItems: fsItemsPopup.value}
		
		HideSheet();
	
		if(editedFeed) EditFeed(editedFeed, settings);
		else AddFeed(settings);
	}
}