/************************************************************************
	Tooltip
*************************************************************************/	

var tFrame, tTitle, tDescription, tUpdated;

function CreateTooltip()
{
	// Tooltip's frame
	tFrame = new Frame(mainWindow);
	tFrame.hAlign = "center";
	tFrame.vAlign = "bottom";
	tFrame.style.backgroundImage = "url(Resources/Images/tooltip.png)";
	tFrame.width = 290;
	tFrame.height = 112;
	tFrame.opacity = 0;
	
	// Tooltip's title
	tTitle = new Text();
	tTitle.hOffset = 17;
	tTitle.vOffset = 19;
	tTitle.width = 258;
	tTitle.font = "Helvetica, Arial";
	tTitle.size = 12;
	tTitle.truncation = "end";
	tTitle.style.fontWeight = "bold";
	tTitle.color = "#ff9b00";
	tFrame.appendChild(tTitle);
	
	// Tooltip's description
	tDescription = new Text();
	tDescription.wrap = true;
	tDescription.hOffset = 17;
	tDescription.vOffset = 23;
	tDescription.width = 258;
	tDescription.font = "Helvetica, Arial";
	tDescription.size = 12;
	tDescription.color = "#e6e6e6";
	tFrame.appendChild(tDescription);
	
	// Tooltip's "updated" text
	tUpdated = new Text();
	tUpdated.hOffset = 17;
	tUpdated.vOffset = 75;
	tUpdated.width = 275;
	tUpdated.size = 10;
	tUpdated.font = "Helvetica, Arial";
	tUpdated.style.fontWeight = "bold";
	tUpdated.style.fontStyle = "italic";
	tUpdated.truncation = "end";
	tUpdated.color = "#b3b3b3";
	tFrame.appendChild(tUpdated);
}

function ShowTooltip(row, title, description, date)
{
	if(overlay.opacity || preferences.descriptionsType.value != "1") return;
	
	if(preferences.descriptionsType.value == "1") tRow = row;

	UpdateTooltip(title,  description, date);
	MoveTooltip(system.event.hOffset, system.event.vOffset);
	
	if(tFrame.fadeOut) tFrame.fadeOut.kill();
	tFrame.fadeIn = new FadeAnimation(tFrame, 255, 10, animator.kEaseOut);
	animator.start(tFrame.fadeIn);
}

function UpdateTooltip(title, description, date)
{
	if(overlay.opacity || preferences.descriptionsType.value != "1") return;

	tTitle.data = title;
	tDescription.data = getShortString(description, date ? 110 : 170);
	
	if(date)
	{
		tUpdated.data = loc("updated") + " " + date;
		tDescription.height = 40;
	}
	else
	{
		tUpdated.data = "";
		tDescription.height = 57;
	}
}

function MoveTooltip(x, y)
{
	if(overlay.opacity || preferences.descriptionsType.value != "1") return;

	tFrame.hOffset = Math.max(tFrame.width/2, x);
	tFrame.vOffset = Math.max(tFrame.height, y - LIST_ROW_HEIGHT + 7);
}

function HideTooltip(synch)
{
	if(preferences.descriptionsType.value == "1") tRow = null;
	if(tFrame.fadeIn) tFrame.fadeIn.kill();
	tFrame.fadeOut = new FadeAnimation(tFrame, 0, 10, animator.kEaseOut);
	synch == true ? animator.runUntilDone(tFrame.fadeOut) : animator.start(tFrame.fadeOut);
}